com.smartgwt.client.widgets.drawing

## Class DrawLinePath

- java.lang.Object
- - com.smartgwt.client.core.BaseClass
  - - com.smartgwt.client.widgets.drawing.DrawItem
    - - com.smartgwt.client.widgets.drawing.DrawLinePath

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasClickHandlers, HasDragMoveHandlers, HasDragResizeMoveHandlers, HasDragStartHandlers, HasDragStopHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseUpHandlers, HasMovedHandlers, HasResizedHandlers, HasShowContextMenuHandlers

      public class DrawLinePath
      extends DrawItem

  DrawItem subclass to render a connector between two points. If the points are aligned on one axis, this connector will draw as a straight line. If the points are offset on both axes and there is enough space, the connector will draw short horizontal segments from the start and end points, and a diagonal segment connecting the ends of these 'margin' segments.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.BaseClass

      `config, id, scClassName`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DrawLinePath()`
    `DrawLinePath(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.core.client.JavaScriptObject` | `create()`
    `ArrowStyle` | `getEndArrow()` Style of arrowhead to draw at the end of the line or path.
    `int` | `getEndLeft()` Ending left coordinate of the line.
    `Point` | `getEndPoint()` End point of the line
    `int` | `getEndTop()` Ending top coordinate of the line.
    `KnobType[]` | `getKnobs()` Array of control knobs to display for this item.
    `static DrawLinePath` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `int` | `getStartLeft()` Starting left coordinate of the line.
    `Point` | `getStartPoint()` Start point of the line
    `int` | `getStartTop()` Starting top coordinate of the line.
    `int` | `getTailSize()` Length of the horizontal "tail" between the start and end points of this LinePath and the diagonal connecting segment
    `void` | `moveBy(int left, int top)` Move both the start and end points of the line by a relative amount.
    `static void` | `setDefaultProperties(DrawLinePath drawLinePathProperties)` Class level method to set the default properties of this class.
    `void` | `setEndArrow(ArrowStyle endArrow)` Style of arrowhead to draw at the end of the line or path.
    `void` | `setEndLeft(int endLeft)` Ending left coordinate of the line.
    `void` | `setEndPoint(Point endPoint)` End point of the line If this method is called after the component has been drawn/initialized: Update the endPoint
    `void` | `setEndTop(int endTop)` Ending top coordinate of the line.
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `void` | `setKnobs(KnobType... knobs)` Array of control knobs to display for this item.
    `void` | `setStartLeft(int startLeft)` Starting left coordinate of the line.
    `void` | `setStartPoint(Point startPoint)` Start point of the line If this method is called after the component has been drawn/initialized: Update the startPoint
    `void` | `setStartTop(int startTop)` Starting top coordinate of the line.
    `void` | `setTailSize(int tailSize)` Length of the horizontal "tail" between the start and end points of this LinePath and the diagonal connecting segment

    - ### Methods inherited from class com.smartgwt.client.widgets.drawing.DrawItem

      `addClickHandler, addDragMoveHandler, addDragResizeMoveHandler, addDragStartHandler, addDragStopHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseUpHandler, addMovedHandler, addResizedHandler, addShowContextMenuHandler, computeAngle, computeAngleAsDouble, dragResizeMove, draw, erase, getAttributeAsIntArray, getBoundingBox, getCanDrag, getCanHover, getCenter, getContextMenu, getCursor, getDestroyed, getDestroying, getDragStartDistance, getDrawGroup, getDrawPane, getFillColor, getFillGradient, getFillOpacity, getHoverHTML, getKeepInParentRect, getLineCap, getLineColor, getLineOpacity, getLinePattern, getLineWidth, getMoveKnobOffset, getMoveKnobPoint, getPageLeft, getPageTop, getPrompt, getRef, getResizeKnobPoints, getRotation, getScale, getShadow, getShowHover, getStartArrow, getSvgString, hide, hideKnobs, hover, isInBounds, isPointInPath, resizeBy, resizeTo, rotateBy, rotateBy, rotateTo, rotateTo, scaleBy, scaleBy, scaleTo, scaleTo, setAttribute, setCanDrag, setCanHover, setContextMenu, setCursor, setDefaultProperties, setDragStartDistance, setDrawGroup, setDrawPane, setFillColor, setFillGradient, setFillOpacity, setKeepInParentRect, setKeepInParentRect, setLineCap, setLineColor, setLineOpacity, setLinePattern, setLineWidth, setMoveKnobOffset, setMoveKnobPoint, setPrompt, setResizeKnobPoints, setRotation, setScale, setShadow, setShowHover, setStartArrow, show, showKnobs`

    - ### Methods inherited from class com.smartgwt.client.core.BaseClass

      `asSGWTComponent, destroy, doAddHandler, doInit, error, error, errorIfNotCreated, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsString, getAttributeAsStringArray, getClassName, getConfig, getHandlerCount, getID, getJsObj, getOrCreateJsObj, getScClassName, internalSetID, internalSetID, isCreated, onBind, onInit, registerID, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setID, setProperty, setProperty, setProperty, setProperty, setScClassName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### DrawLinePath

          public DrawLinePath()

    - #### DrawLinePath

          public DrawLinePath(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static DrawLinePath getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

      Overrides:
        `setJavaScriptObject` in class `DrawItem`

    - #### create

          public com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `DrawItem`

    - #### setEndArrow

          public void setEndArrow(ArrowStyle endArrow)

      Style of arrowhead to draw at the end of the line or path.
      Overrides:
        `setEndArrow` in class `DrawItem`
      Parameters:
        `endArrow` - endArrow Default value is "open", IRW

    - #### getEndArrow

          public ArrowStyle getEndArrow()

      Style of arrowhead to draw at the end of the line or path.
      Overrides:
        `getEndArrow` in class `DrawItem`
      Returns:
        ArrowStyle

    - #### setEndLeft

          public void setEndLeft(int endLeft)
                          throws java.lang.IllegalStateException

      Ending left coordinate of the line. Overrides left coordinate of `endPoint` if both are set.
      Parameters:
        `endLeft` - endLeft Default value is 0 , IRW
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getEndLeft

          public int getEndLeft()

      Ending left coordinate of the line. Overrides left coordinate of `endPoint` if both are set.
      Returns:
        int

    - #### setEndPoint

          public void setEndPoint(Point endPoint)

      End point of the line
      If this method is called after the component has been drawn/initialized: Update the endPoint
      Parameters:
        `endPoint` - left coordinate for end point, in pixels. Default value is [100,100]

    - #### getEndPoint

          public Point getEndPoint()

      End point of the line
      Returns:
        Point

    - #### setEndTop

          public void setEndTop(int endTop)
                         throws java.lang.IllegalStateException

      Ending top coordinate of the line. Overrides top coordinate of `endPoint` if both are set.
      Parameters:
        `endTop` - endTop Default value is 0 , IRW
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getEndTop

          public int getEndTop()

      Ending top coordinate of the line. Overrides top coordinate of `endPoint` if both are set.
      Returns:
        int

    - #### setKnobs

          public void setKnobs(KnobType... knobs)

      Array of control knobs to display for this item. Each `KnobType` specified in this will turn on UI element(s) allowing the user to manipulate this DrawLinePath. To update the set of knobs at runtime use `DrawItem.showKnobs` and `DrawItem.hideKnobs`.

      DrawLinePath supports the `KnobType.STARTPOINT` and `KnobType.ENDPOINT` knob types.

      Overrides:
        `setKnobs` in class `DrawItem`
      Parameters:
        `knobs` - knobs Default value is null

    - #### getKnobs

          public KnobType[] getKnobs()

      Array of control knobs to display for this item. Each `KnobType` specified in this will turn on UI element(s) allowing the user to manipulate this DrawLinePath. To update the set of knobs at runtime use `DrawItem.showKnobs` and `DrawItem.hideKnobs`.

      DrawLinePath supports the `KnobType.STARTPOINT` and `KnobType.ENDPOINT` knob types.

      Overrides:
        `getKnobs` in class `DrawItem`
      Returns:
        KnobType

    - #### setStartLeft

          public void setStartLeft(int startLeft)
                            throws java.lang.IllegalStateException

      Starting left coordinate of the line. Overrides left coordinate of `startPoint` if both are set.
      Parameters:
        `startLeft` - startLeft Default value is 0 , IRW
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getStartLeft

          public int getStartLeft()

      Starting left coordinate of the line. Overrides left coordinate of `startPoint` if both are set.
      Returns:
        int

    - #### setStartPoint

          public void setStartPoint(Point startPoint)

      Start point of the line
      If this method is called after the component has been drawn/initialized: Update the startPoint
      Parameters:
        `startPoint` - left coordinate for start point, in pixels. Default value is [0,0]

    - #### getStartPoint

          public Point getStartPoint()

      Start point of the line
      Returns:
        Point

    - #### setStartTop

          public void setStartTop(int startTop)
                           throws java.lang.IllegalStateException

      Starting top coordinate of the line. Overrides top coordinate of `startPoint` if both are set.
      Parameters:
        `startTop` - startTop Default value is 0 , IRW
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getStartTop

          public int getStartTop()

      Starting top coordinate of the line. Overrides top coordinate of `startPoint` if both are set.
      Returns:
        int

    - #### setTailSize

          public void setTailSize(int tailSize)
                           throws java.lang.IllegalStateException

      Length of the horizontal "tail" between the start and end points of this LinePath and the diagonal connecting segment
      Parameters:
        `tailSize` - tailSize Default value is 30
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created

    - #### getTailSize

          public int getTailSize()

      Length of the horizontal "tail" between the start and end points of this LinePath and the diagonal connecting segment
      Returns:
        int

    - #### moveBy

          public void moveBy(int left,
                    int top)

      Move both the start and end points of the line by a relative amount.
      Overrides:
        `moveBy` in class `DrawItem`
      Parameters:
        `left` - change to left coordinate in pixels
        `top` - change to top coordinate in pixels

    - #### setDefaultProperties

          public static void setDefaultProperties(DrawLinePath drawLinePathProperties)

      Class level method to set the default properties of this class. If set, then all subsequent instances of this class will automatically have the default properties that were set when this method was called. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will effect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead.

      Parameters:
        `drawLinePathProperties` - properties that should be used as new defaults when instances of this class are created